#ifndef WIN9X

#include "scaler.h"

/********** 2XSAI Filter *****************/
extern "C"
{
	void _2xSaILine (uint8 *srcPtr, uint8 *deltaPtr, uint32 srcPitch, uint32 width, uint8 *dstPtr, uint32 dstPitch);
	void _2xSaISuperEagleLine (uint8 *srcPtr, uint8 *deltaPtr, uint32 srcPitch, uint32 width, uint8 *dstPtr, uint32 dstPitch);
	void _2xSaISuper2xSaILine (uint8 *srcPtr, uint8 *deltaPtr, uint32 srcPitch, uint32 width, uint8 *dstPtr, uint32 dstPitch);
	void hq2x_16(const uint8 *, uint8 *, uint32, uint32, uint32, uint32);
	int Init_2xSaIMMX (uint32 BitFormat);
}
//void HQ2x_565(const uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, int width, int height);

int Init_2xSaI(uint32 BitFormat) {
	return Init_2xSaIMMX (BitFormat);
}

void Super2xSaI(uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, int width, int height) {
	while (height--) {
		_2xSaISuper2xSaILine (srcPtr, 0, srcPitch, width, dstPtr, dstPitch);
		srcPtr += srcPitch;
		dstPtr += dstPitch * 2;
	}
}

void SuperEagle(uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, int width, int height) {
	while (height--) {
		_2xSaISuperEagleLine (srcPtr, 0, srcPitch, width, dstPtr, dstPitch);
		srcPtr += srcPitch;
		dstPtr += dstPitch * 2;
	}
}

void _2xSaI(uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, int width, int height) {
	while (height--) {
		_2xSaILine (srcPtr, 0, srcPitch, width, dstPtr, dstPitch); 
		srcPtr += srcPitch;
		dstPtr += dstPitch * 2;
	}
}

void HQ2x(const uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, int width, int height) {
	//HQ2x_565(srcPtr, srcPitch, dstPtr, dstPitch, width, height);
	hq2x_16(srcPtr, dstPtr, width, height, srcPitch, dstPitch);
}

#endif