#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "main.h"
#include "safewrite.h"

static const DWORD DamageFunctionSub1 = 0x00478448;
static const DWORD DamageFunctionReturn = 0x00424A63;
//AP ammo / Combat overhaul
static _declspec(naked) void DamageFunction() {
_asm {
bJmp:
mov edx,dword ptr ds:[esi+0x4]; // start of damage loop
mov eax,dword ptr ds:[esi]; //
mov ebx,dword ptr ss:[esp+0x18]; //
call [DamageFunctionSub1]; //
add ebx,eax; // raw damage
mov dword ptr ss:[esp+0x30],0x64; //

cmp dword ptr ss:[esp+0x2c],0x64; // check adjustor value
jge nJmp; //

cmp dword ptr ss:[esp+0x2c],0; // check adjustor value
jle cJmp; //

mov eax,0x64; //
sub eax,dword ptr ss:[esp+0x2c]; // adjustor less than one hundred and greater than zero
imul ebx,eax; // damage multiplied by adjustor
mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
mov ebx,eax; // assign new damage value

cJmp:
cmp dword ptr ss:[esp+0x28],4; // armor type check
jl uJmp; //
jge vJmp; //

uJmp:
cmp dword ptr ss:[esp+0x24],0x12; //
jne uuJmp; //

add ebx,1; //
jmp mJmp; //

uuJmp:
cmp dword ptr ss:[esp+0x24],0xE; //
jne mJmp; //

sub ebx,3; //
jmp mJmp; //

vJmp:
cmp dword ptr ss:[esp+0x24],0xE; //
jne mJmp; //

add ebx,5; //

mJmp:
cmp dword ptr ss:[esp+0x28],0; //
jle oJmp; //

sub ebx,dword ptr ss:[esp+0x28]; // damage minus threshold

oJmp:
cmp ebx,0; //
jle nJmp; // no damage

imul ebx,dword ptr ss:[esp+0x20]; // damage multiplied by the difficulty setting
mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
mov ebx,eax; // assign new damage value

cmp ebx,0; //
jle aJmp; // no damage

cmp dword ptr ss:[esp+0x24],0; //
jle aJmp; // no damage

imul ebx,dword ptr ss:[esp+0x24]; // damage multiplied by damage multiplier
sar ebx,1; //

cmp ebp,0; //
jle aJmp; // protect against divison by zero

mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv ebp; // damage divided by the damage divisor
mov ebx,eax; // assign new damage value

cmp dword ptr ss:[esp+0x28],4; // armor type check
jl xJmp; //
jge yJmp; //

xJmp:
cmp dword ptr ss:[esp+0x24],4; //
jne xxJmp; //

cmp ebp,1; //
jne aJmp; //

imul ebx,9; // damage multiplied by nine
mov dword ptr ss:[esp+0x30],0xA; //
mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv dword ptr ss:[esp+0x30]; // damage divided by ten
mov ebx,eax; // assign new damage value
jmp aJmp; //

xxJmp:
cmp dword ptr ss:[esp+0x24],2; //
jne aJmp; //

cmp ebp,2; //
jne aJmp; //

imul ebx,7; // damage multiplied by seven
sar ebx,2; // damage divided by four
jmp aJmp; //

yJmp:
cmp dword ptr ss:[esp+0x24],4; //
jne yyJmp; //

cmp ebp,1; //
jne aJmp; //

imul ebx,5; // damage multiplied by five
sar ebx,2; // damage divided by four
jmp aJmp; //

yyJmp:
cmp dword ptr ss:[esp+0x24],2; //
jne aJmp; //

cmp ebp,2; //
jne aJmp; //

imul ebx,5; // damage multiplied by five
sar ebx,1; // damage divided by two

aJmp:
mov dword ptr ss:[esp+0x30],0x64; //
add dword ptr ds:[edi],ebx; // accumulate damage

nJmp:
mov dword ptr ss:[esp+0x30],0x64; //
mov eax,dword ptr ss:[esp+0x1c]; // no damage
inc ecx; //
cmp ecx,eax; //
jl bJmp; // loop back to beginning
jmp [DamageFunctionReturn];
}
}
//Damage tweak
static _declspec(naked) void DamageFunction2() {
_asm {
bjmp:
mov edx,dword ptr ds:[esi+4]; // start of damage loop
mov eax,dword ptr ds:[esi]; //
mov ebx,dword ptr ss:[esp+0x18]; //
call DamageFunctionSub1; //
add ebx,eax; // raw damage
mov dword ptr ss:[esp+0x30],0x64; //

cmp dword ptr ss:[esp+0x2c],0x64; // check adjustor value
jge nJmp; //

cmp dword ptr ss:[esp+0x2c],0; // check adjustor value
jle mJmp; //

mov eax,0x64; //
sub eax,dword ptr ss:[esp+0x2c]; // adjustor less than one hundred and greater than zero
imul ebx,eax; // damage multiplied by adjustor
mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
mov ebx,eax; // assign new damage value

mJmp:
cmp dword ptr ss:[esp+0x28],0; //
jle oJmp; //

sub ebx,dword ptr ss:[esp+0x28]; // damage minus threshold

oJmp:
cmp ebx,0; //
jle nJmp; // no damage

imul ebx,dword ptr ss:[esp+0x20]; // damage multiplied by the difficulty setting
mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
mov ebx,eax; // assign new damage value

cmp ebx,0; //
jle aJmp; // no damage

cmp dword ptr ss:[esp+0x24],0; //
jle aJmp; //

imul ebx,dword ptr ss:[esp+0x24]; // damage multiplied by damage multiplier
sar ebx,1; //

cmp ebp,0; //
jle aJmp; // protect against divison by zero

mov edx,ebx; //
mov eax,ebx; //
sar edx,0x1f; //
idiv ebp; // damage divided by the damage divisor
mov ebx,eax; // assign new damage value

ajmp:
add dword ptr ds:[edi],ebx; // accumulate damage

njmp:
mov eax,dword ptr ss:[esp+0x1c]; // no damage
inc ecx; //
cmp ecx,eax; //
jl bjmp; // loop back to beginning
jmp DamageFunctionReturn;
}
}
//Old ap ammo mod
static _declspec(naked) void DamageFunction3() {
	_asm {
bJmp:
		mov edx,dword ptr ds:[esi+0x4]; // start of damage loop
		mov eax,dword ptr ds:[esi]; //
		mov ebx,dword ptr ss:[esp+0x18]; //
		call [DamageFunctionSub1];
		add ebx,eax; // raw damage

		sub ebx,dword ptr ss:[esp+0x28]; // damage minus threshold

		test ebx,ebx; //
		jle nJmp; // no damage

		cmp dword ptr ss:[esp+0x2c],0x64; //
		jl vJmp; //

		mov eax,0; // adjustor equals zero
		jmp nJmp; //

vJmp:
		cmp dword ptr ss:[esp+0x2c],0; //
		jle wJmp; //

		mov eax,0x64; //
		sub eax,dword ptr ss:[esp+0x2c]; //
		jmp mJmp; //

wJmp:
		mov eax,0x64; // adjustor equals one hundred

mJmp:
		imul ebx,eax; // damage multiplied by adjustor
		imul ebx,dword ptr ss:[esp+0x20]; // damage multiplied by the difficulty setting
		imul ebx,dword ptr ss:[esp+0x24]; // damage multiplied by damage multiplier
		sar ebx,1; //
		mov dword ptr ss:[esp+0x30],0x64; //
		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
		mov ebx,eax; // assign new damage value
		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
		mov ebx,eax; // assign new damage value

		test ebp,ebp; //
		jle aJmp; // add damage

		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv ebp; // damage divided by the damage divisor
		mov ebx,eax; // assign new damage value

		cmp dword ptr ss:[esp+0x24],4; //
		jg aJmp; // add damage
		je zJmp; // jhp ammo damage decrease

		cmp ebp,2; //
		jnz aJmp; // add damage

		cmp dword ptr ss:[esp+0x28],4; //
		jge xJmp; // ap ammo damage increase
		jl yJmp; // ap ammo damage decrease

xJmp:
		imul eax,3; // multiple damage by three
		sar eax,1; // divide damage by two
		add ebx,eax; // add result to previous damage value
		jmp aJmp; // add damage

yJmp:
		sar eax,1; // divide damage by two
		add ebx,eax; // add result to previous damage value
		jmp aJmp; // add damage

zJmp:
		cmp ebp,1; //
		jnz aJmp; // add damage

		cmp dword ptr ss:[esp+0x28],4; //
		jge cJmp; //

		imul eax,0x0d; // multiple damage by thirteen
		sar eax,6; // divide damage by sixty-four
		sub ebx,eax; // subtract result from previous damage value
		jmp aJmp; // add damage

cJmp:
		sar eax,2; // divide damage by four
		sub ebx,eax; // subtract result from previous damage value

aJmp:
		add dword ptr ds:[edi],ebx; // accumulate damage

nJmp:
		mov eax,dword ptr ss:[esp+0x1c]; // no damage
		inc ecx; //
		cmp ecx,eax; //
		jl bJmp; // loop back to beginning
		jmp [DamageFunctionReturn];
	}
}
//old damage tweak mod
static _declspec(naked) void DamageFunction4() {
	_asm {
bjmp:
		mov edx,dword ptr ds:[esi+4]; // start of damage loop
		mov eax,dword ptr ds:[esi]; //
		mov ebx,dword ptr ss:[esp+0x18]; //
		call DamageFunctionSub1; //
		add ebx,eax; // raw damage

		sub ebx,dword ptr ss:[esp+0x28]; // damage minus threshold

		test ebx,ebx; //
		jle njmp; // no damage

		cmp dword ptr ss:[esp+0x2c],0x64; //
		jl vjmp; //

		mov eax,0; // adjustor equals zero
		jmp njmp; //

vjmp:
		cmp dword ptr ss:[esp+0x2c],0; //
		jle wjmp; //

		mov eax,0x64; //
		sub eax,dword ptr ss:[esp+0x2c]; //
		jmp mjmp; //

wjmp:
		mov eax,0x64; // adjustor equals one hundred

mjmp:
		imul ebx,eax; // damage multiplied by adjustor
		imul ebx,dword ptr ss:[esp+0x20]; // damage multiplied by the difficulty setting
		imul ebx,dword ptr ss:[esp+0x24]; // damage multiplied by damage multiplier
		sar ebx,1; //
		mov dword ptr ss:[esp+0x30],0x64; //
		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
		mov ebx,eax; // assign new damage value
		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv dword ptr ss:[esp+0x30]; // damage divided by one hundred
		mov ebx,eax; // assign new damage value

		test ebp,ebp; //
		jle ajmp; // add damage

		mov edx,ebx; //
		mov eax,ebx; //
		sar edx,0x1f; //
		idiv ebp; // damage divided by the damage divisor
		mov ebx,eax; // assign new damage value

ajmp:
		add dword ptr ds:[edi],ebx; // accumulate damage

njmp:
		mov eax,dword ptr ss:[esp+0x1c]; // no damage
		inc ecx; //
		cmp ecx,eax; //
		jl bjmp; // loop back to beginning
		jmp DamageFunctionReturn;
	}
}
void AmmoModInit() {
	int formula;
	if(formula=GetPrivateProfileInt("Misc", "DamageFormula", 0, ini)) {
		SafeWrite8(0x004249ec, 0xe9);
		switch(formula) {
			case 1:
				SafeWrite32(0x004249ed, ((DWORD)&DamageFunction) - 0x004249f1);
				break;
			case 2:
				SafeWrite32(0x004249ed, ((DWORD)&DamageFunction2) - 0x004249f1);
				break;
			case 3:
				SafeWrite32(0x004249ed, ((DWORD)&DamageFunction3) - 0x004249f1);
				break;
			case 4:
				SafeWrite32(0x004249ed, ((DWORD)&DamageFunction4) - 0x004249f1);
				break;
		}
	}
}