#define STRICT
//#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#ifndef WIN9X
#include <math.h>
#endif
#include "timer.h"
#include "SafeWrite.h"
#include "version.h"
#include "Graphics.h"
#include "LoadGameHook.h"
#include "AmmoMod.h"
#include "Logging.h"

char ini[65];

#include "ScriptExtender.h"
#include "knockback.h"
#include "perks.h"
#include "KillCounter.h"
#include "Elevators.h"

static char mapName[65];
static char configName[65];
static char patchName[65];
static char versionString[65];

char MovieNames[17*65];

static char smModelName[65];
char dmModelName[65];
static char sfModelName[65];
char dfModelName[65];

static const char* debugLog="LOG";
static const char* debugGnw="GNW";
DWORD InputHookEnabled=0;

bool npcautolevel;

static const char* origMovieNames[] = {
	"iplogo.mve",
	"intro.mve",
	"elder.mve",
	"vsuit.mve",
	"afailed.mve",
	"adestroy.mve",
	"car.mve",
	"cartucci.mve",
	"timeout.mve",
	"tanker.mve",
	"enclave.mve",
	"derrick.mve",
	"artimer1.mve",
	"artimer2.mve",
	"artimer3.mve",
	"artimer4.mve",
	"credits.mve",
};

//GetTickCount calls
static const DWORD offsetsA[] = {
    0x004c8d34,
	0x004c9375,
	0x004c9384,
	0x004c93c0,
	0x004c93e8,
	0x004c9d2e,
	0x004fe01e,
};

//Delayed GetTickCount calls
static const DWORD offsetsB[] = {
	0x004fdf64,
};

//timeGetTime calls
static const DWORD offsetsC[] = {
    0x004a3179,
	0x004a325d,
	0x004f482b,
	0x004f4e53,
	0x004f5542,
	0x004f56cc,
	0x004f59c6,
	0x004fe036,
};

static const DWORD origFuncPosA=0x006c0200;
static const DWORD origFuncPosB=0x006c03b0;
static const DWORD origFuncPosC=0x006c0164;

static const DWORD getLocalTimePos=0x004fdf58;

static const DWORD dinputPos=0x0050FB70;
static const DWORD DDrawPos=0x0050FB5C;

static DWORD AddrGetTickCount;
static DWORD AddrGetLocalTime;

static DWORD ViewportX;
static DWORD ViewportY;

static __declspec(naked) void GetDateWrapper() {
	_asm {
		push ecx;
		push esi;
		push ebx;
		mov ecx, 0x004A3338;
		call ecx;
		mov ecx, ds:[0x51C3BC];
		pop esi;
		test esi, esi;
		jz end;
		add ecx, [esi];
		mov [esi], ecx;
end:
		pop esi;
		pop ecx;
		retn;
	}
}
static void TimerReset() {
	*((DWORD*)0x51C720)=0;
	*((DWORD*)0x51C3BC)+=13;
}

static double TickFrac=0;
static double MapMulti=1;
static __declspec(naked) void PathfinderFix3() {
	_asm {
		xor eax, eax;
		retn;
	}
}
static DWORD _stdcall PathfinderFix2(DWORD perkLevel, DWORD ticks) {
	double d = MapMulti;
	if(perkLevel) d*=(perkLevel==1?0.75:0.5);
	d=((double)ticks)*d + TickFrac;
	TickFrac = modf(d, &d);
	return (DWORD)d;
}
static __declspec(naked) void PathfinderFix() {
	_asm {
		push ebx;
		push eax;
		mov eax, ds:[0x006610B8];
		mov edx, 0x2b;
		mov ebx, 0x00496B78;
		call ebx;
		push eax;
		call PathfinderFix2;
		mov ebx, 0x004A34CC;
		call ebx;
		pop ebx;
		retn;
	}
}

static double FadeMulti;
static __declspec(naked) void FadeHook() {
	_asm {
		push ecx;
		pushf;
		push ebx;
		fild [esp];
		fmul FadeMulti;
		fistp [esp];
		pop ebx;
		popf;
		mov ecx, 0x004C7320;
		call ecx;
		pop ecx;
		retn;
	}
}

static int mapSlotsScrollMax=27 * (17 - 7);

static _declspec(naked) void ScrollCityListHook() {
	_asm {
		push ebx;
		mov ebx, ds:[0x672F10];
		test eax, eax;
		jl up;
		cmp ebx, mapSlotsScrollMax;
		je end;
		jmp run;
up:
		test ebx, ebx;
		jz end;
run:
		mov ebx, 0x004C219C;
		call ebx;
end:
		pop ebx;
		retn;
	}
}


/*extern DWORD gWidth;
extern DWORD gHeight;
static const DWORD AddrBasicSetup=0x004CAE1C;
static int __declspec(naked) SetRes() {
	__asm {
		push ebx;
		push edx;
		mov eax, gWidth;
		mov edx, gHeight;
		mov ebx, 8;
		call AddrBasicSetup;
		pop ebx;
		pop edx;
		retn;
	}
}*/

static const DWORD WorldMapMoveFunc=0x004C1F90;
static void _declspec(naked) WorldMapEncPatch1() {
	_asm {
		inc dword ptr ds:[0x51dea0]
		call WorldMapMoveFunc;
		retn;
	}
}
static void _declspec(naked) WorldMapEncPatch2() {
	_asm {
		mov dword ptr ds:[0x51dea0],0;
		retn;
	}
}
static void _declspec(naked) WorldMapEncPatch3() {
	_asm {
		mov eax,ds:[0x51dea0];
		retn;
	}
}
static const DWORD Combat_p_procFixFunc0=0x4AEF48; //&GetCurrentStat(void* critter, int statID)
static const DWORD Combat_p_procFixFunc1=0x4a3b0c;
static const DWORD Combat_p_procFixFunc2=0x4a3b34;
static const DWORD Combat_p_procFixFunc3=0x4a4810;
static void _declspec(naked) Combat_p_procFix() {
	_asm {	
		push eax;

		mov eax,dword ptr ds:[0x510944];
		cmp eax,3;
		jnz end_cppf; 

		push esi;
		push ebx;
		push edx;

		mov esi,0x56d2b0;
		mov eax,[esi];       
		mov ebx,[esi+0x20];
		xor edx,edx;      
		mov eax,[eax+0x78];
		call Combat_p_procFixFunc1;     
		mov eax,[esi]; 
		
		cmp dword ptr ds:[esi+0x2c],+0x0;
		jng jmp1;

		test byte ptr ds:[esi+0x15],0x1;
		jz jmp1;
		mov edx,0x2;       
		jmp jmp2;
jmp1:
		mov edx,0x1;
jmp2:
		mov eax,[eax+0x78];
		call Combat_p_procFixFunc2;
		mov eax,[esi];     
		mov edx,0xd;       
		mov eax,[eax+0x78];
		call Combat_p_procFixFunc3;
		pop edx;
		pop ebx;
		pop esi;

end_cppf: 
		pop eax;
		call Combat_p_procFixFunc0;

		retn;
	}
}
static double wm_nexttick;
static double wm_wait;
static bool wm_usingperf;
static __int64 wm_perfadd;
static __int64 wm_perfnext;
static DWORD WorldMapLoopCount;
static const DWORD WorldMapRealFunc=0x004C8B78;
static void WorldMapSpeedPatch3() {
	RunGlobalScripts3();
	if(wm_usingperf) {
		__int64 timer;
		while(true) {
			QueryPerformanceCounter((LARGE_INTEGER*)&timer);
			if(timer>wm_perfnext) break;
			Sleep(0);
		}
		if(wm_perfnext+wm_perfadd < timer) wm_perfnext = timer+wm_perfadd;
		else wm_perfnext+=wm_perfadd;
	} else {
		DWORD tick;
		DWORD nexttick=(DWORD)wm_nexttick;
		while((tick=GetTickCount())<nexttick) Sleep(0);
		if(nexttick+wm_wait < tick) wm_nexttick = tick + wm_wait;
		else wm_nexttick+=wm_wait;
	}
}
static void _declspec(naked) WorldMapSpeedPatch2() {
	_asm {
		pushad;
		call WorldMapSpeedPatch3;
		popad;
		call WorldMapRealFunc;
		retn;
	}
}
static void _declspec(naked) WorldMapSpeedPatch() {
	_asm {
		pushad;
		call RunGlobalScripts3;
		popad;
		push ecx;
		mov ecx, WorldMapLoopCount;
ls:
		mov eax, eax;
		loop ls;
		pop ecx;
		call WorldMapRealFunc;
		retn;
	}
}
//Only used if the world map speed patch is disabled, so that world map scripts are still run
static void WorldMapHook() {
	_asm {
		pushad;
		call RunGlobalScripts3;
		popad;
		call WorldMapRealFunc;
		retn;
	}
}

static void _declspec(naked) LevelUpHook() {
	_asm {
		pushad;
		mov eax, 0xe;
		mov ebx, 0x004B3BC8;
		call ebx; //Check if the player has the skilled trait
		mov ebx, ds:[0x006681B0];	//Get players level
		inc ebx;
		mov ecx, 3;
		test eax, eax;
		jz notskilled;
		inc ecx;
notskilled:
		mov eax, ebx;
		xor edx, edx;
		div ecx;	//Is there a mod instruction in x86 asm?
		mul ecx;
		sub ebx, eax;
		test ebx, ebx;
		jnz end;
		inc byte ptr ds:[0x00570A29]; //Incremenent the number of perks owed
end:
		popad;
		mov edx, ds:[0x006681B0];
		retn;
	}
}
static void _declspec(naked) ViewportHook() {
	_asm {
		mov eax, 0x004BD6B4;
		call eax;
		mov eax, ViewportX;
		mov ds:[0x51DE2C], eax
		mov eax, ViewportY;
		mov ds:[0x51DE30], eax
		retn;
	}
}
static void _declspec(naked) BlackSkilldexFix() {
	_asm {
		push ecx;
		mov ecx, 0x004998C0;
		call ecx;
		xor ecx, ecx;
		mov dword ptr ds:[0x006644F8], ecx;
		pop ecx;
		retn;
	}
}
HANDLE _stdcall FakeFindFirstFile(const char* str, WIN32_FIND_DATAA* data) {
	HANDLE h=FindFirstFileA(str,data);
	if(h==INVALID_HANDLE_VALUE) return h;
	while(strlen(data->cFileName)>12) {
		int i=FindNextFileA(h, data);
		if(i==0) {
			FindClose(h);
			return INVALID_HANDLE_VALUE;
		}
	}
	return h;
}
int _stdcall FakeFindNextFile(HANDLE h, WIN32_FIND_DATAA* data) {
	int i=FindNextFileA(h, data);
	while(strlen(data->cFileName)>12&&i) {
		i=FindNextFileA(h, data);
	}
	return i;
}
static bool DllMain2() {
	dlogr("In DllMain2");
	if(GetPrivateProfileIntA("Speed", "Enable", 0, ini)) {
		dlog("Applying speed patch.");
		AddrGetTickCount = (DWORD)&FakeGetTickCount;
		AddrGetLocalTime = (DWORD)&FakeGetLocalTime;

		for(int i=0;i<sizeof(offsetsA)/4;i++) {
			if(*((DWORD*)offsetsA[i])!=origFuncPosA) return false;
			SafeWrite32(offsetsA[i], (DWORD)&AddrGetTickCount);
		}
		dlog(".");
		for(int i=0;i<sizeof(offsetsB)/4;i++) {
			if(*((DWORD*)offsetsB[i])!=origFuncPosB) return false;
			SafeWrite32(offsetsB[i], (DWORD)&AddrGetTickCount);
		}dlog(".");
		for(int i=0;i<sizeof(offsetsC)/4;i++) {
			if(*((DWORD*)offsetsC[i])!=origFuncPosC) return false;
			SafeWrite32(offsetsC[i], (DWORD)&AddrGetTickCount);
		}
		dlog(".");

		SafeWrite32(getLocalTimePos, (DWORD)&AddrGetLocalTime);
		TimerInit();
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Input", "Enable", 0, ini)) {
		dlog("Applying input patch.");
		if(strcmp((char*)dinputPos,"DINPUT.DLL")) return false;
#ifdef WIN9X
		SafeWriteStr(dinputPos, "SFALL.DLL");
#else
		SafeWriteStr(dinputPos, "ddraw.dll");
#endif
		InputHookEnabled=1;
		AvailableGlobalScriptTypes|=1;
		dlogr(" Done");
	}

#ifndef WIN9X
	GraphicsMode=GetPrivateProfileIntA("Graphics", "Mode", 0, ini);
	if(GraphicsMode!=4&&GraphicsMode!=5) GraphicsMode=0;
	if(GraphicsMode==4||GraphicsMode==5) {
		dlog("Applying dx9 graphics patch.");
		if(*(BYTE*)0x0050FB6B!='e') return false;
		SafeWrite8(0x0050FB6B, '2');
		dlogr(" Done");
	}
#endif
	DWORD fade=GetPrivateProfileIntA("Graphics", "FadeMultiplier", 100, ini);
	if(fade!=100) {
		dlog("Applying fade patch.");
		SafeWrite32(0x00493B17, ((DWORD)&FadeHook) - 0x00493B1b);
		FadeMulti=((double)fade)/100.0;
		dlogr(" Done");
	}

	AmmoModInit();

	mapName[64]=0;
	if(GetPrivateProfileString("Misc", "StartingMap", "", mapName, 64, ini)) {
		dlog("Applying starting map patch.");
		if(*((DWORD*)0x00480AAA)!=0x005194c8) return false;
		SafeWrite32(0x00480AAA, (DWORD)&mapName);
		dlogr(" Done");
	}

	versionString[64]=0;
	if(GetPrivateProfileString("Misc", "VersionString", "", versionString, 64, ini)) {
		dlog("Applying version string patch.");
		if(*((DWORD*)0x004B4588)!=0x0050ea18) return false;
		SafeWrite32(0x004B4588, (DWORD)&versionString);
		dlogr(" Done");
	}

	configName[64]=0;
	if(GetPrivateProfileString("Misc", "ConfigFile", "", configName, 64, ini)) {
		dlog("Applying config file patch.");
		if(*((DWORD*)0x00444BA5)!=0x0050281C) return false;
		SafeWrite32(0x00444BA5, (DWORD)&configName);
		SafeWrite32(0x00444BCA, (DWORD)&configName);
		dlogr(" Done");
	}

	patchName[64]=0;
	if(GetPrivateProfileString("Misc", "PatchFile", "", patchName, 64, ini)) {
		dlog("Applying patch file patch.");
		if(*((DWORD*)0x00444323)!=0x005023C8) return false;
		SafeWrite32(0x00444323, (DWORD)&patchName);
		dlogr(" Done");
	}

	smModelName[64]=0;
	if(GetPrivateProfileString("Misc", "MaleStartModel", "", smModelName, 64, ini)) {
		dlog("Applying male start model patch.");
		if(*((DWORD*)0x00418B88)!=0x005002E8) return false;
		SafeWrite32(0x00418B88, (DWORD)&smModelName);
		dlogr(" Done");
	}

	sfModelName[64]=0;
	if(GetPrivateProfileString("Misc", "FemaleStartModel", "", sfModelName, 64, ini)) {
		dlog("Applying female start model patch.");
		if(*((DWORD*)0x00418BAB)!=0x005002F0) return false;
		SafeWrite32(0x00418BAB, (DWORD)&sfModelName);
		dlogr(" Done");
	}

	dmModelName[64]=0;
	GetPrivateProfileString("Misc", "MaleDefaultModel", "hmjmps", dmModelName, 64, ini);
	dlog("Applying male model patch.");
	if(*((DWORD*)0x00418B50)!=0x005002D8) return false;
	SafeWrite32(0x00418B50, (DWORD)&dmModelName);
	dlogr(" Done");

	dfModelName[64]=0;
	GetPrivateProfileString("Misc", "FemaleDefaultModel", "hfjmps", dfModelName, 64, ini);
	dlog("Applying female model patch.");
	if(*((DWORD*)0x00418B6D)!=0x005002E0) return false;
	SafeWrite32(0x00418B6D, (DWORD)&dfModelName);
	dlogr(" Done");

	int date=GetPrivateProfileInt("Misc", "StartYear", -1, ini);
	if(date!=-1) {
		dlog("Applying starting year patch.");
		if(*((DWORD*)0x4A336C) != 0x8c1) return false;
		SafeWrite32(0x4A336C, date);
		dlogr(" Done");
	}
	date=GetPrivateProfileInt("Misc", "StartMonth", -1, ini);
	if(date!=-1) {
		dlog("Applying starting month patch.");
		if(*((DWORD*)0x4A3382) != 0x6) return false;
		SafeWrite32(0x4A3382, date);
		dlogr(" Done");
	}
	date=GetPrivateProfileInt("Misc", "StartDay", -1, ini);
	if(date!=-1) {
		dlog("Applying starting day patch.");
		if(*((BYTE*)0x4A3356) != 0x18) return false;
		SafeWrite8(0x4A3356, date);
		dlogr(" Done");
	}

	date=GetPrivateProfileInt("Misc", "LocalMapXLimit", 0, ini);
	if(date) {
		dlog("Applying local map x limit patch.");
		if(*((DWORD*)0x004B13B9) != 0x1E0) return false;
		SafeWrite32(0x004B13B9, date);
		dlogr(" Done");
	}
	date=GetPrivateProfileInt("Misc", "LocalMapYLimit", 0, ini);
	if(date) {
		dlog("Applying local map y limit patch.");
		if(*((DWORD*)0x004B13C7) != 0x190) return false;
		SafeWrite32(0x004B13C7, date);
		dlogr(" Done");
	}

	date=GetPrivateProfileInt("Misc", "StartXPos", -1, ini);
	if(date!=-1) {
		dlog("Applying starting x position patch.");
		if(*((DWORD*)0x4BC990) != 0xAD) return false;
		SafeWrite32(0x4BC990, date);
		SafeWrite32(0x4BCC08, date);
		dlogr(" Done");
	}
	date=GetPrivateProfileInt("Misc", "StartYPos", -1, ini);
	if(date!=-1) {
		dlog("Applying starting y position patch.");
		if(*((DWORD*)0x4BC995) != 0x7A) return false;
		SafeWrite32(0x4BC995, date);
		SafeWrite32(0x4BCC0D, date);
		dlogr(" Done");
	}
	ViewportX=GetPrivateProfileInt("Misc", "ViewXPos", -1, ini);
	if(ViewportX!=-1) {
		dlog("Applying starting x view patch.");
		if(*((DWORD*)0x51DE2C) != 0x0) return false;
		SafeWrite32(0x51DE2C, ViewportX);
		SafeWrite32(0x004BCF08, (DWORD)&ViewportHook - 0x4BCF0C);
		dlogr(" Done");
	}
	ViewportY=GetPrivateProfileInt("Misc", "ViewYPos", -1, ini);
	if(ViewportY!=-1) {
		dlog("Applying starting y view patch.");
		if(*((DWORD*)0x51DE30) != 0x0) return false;
		SafeWrite32(0x51DE30, ViewportY);
		SafeWrite32(0x004BCF08, (DWORD)&ViewportHook - 0x4BCF0C);
		dlogr(" Done");
	}

	dlog("Applying movie patch.");
	if(*((DWORD*)0x00518DA0)!=0x00503300) return false;
	for(int i=0;i<17;i++) {
		dlog(".");
		MovieNames[i*65+64]=0;
		char ininame[8];
		strcpy_s(ininame,"Movie");
		_itoa_s(i+1, &ininame[5], 3, 10);
		GetPrivateProfileString("Misc", ininame, origMovieNames[i], &MovieNames[i*65], 64, ini);
		SafeWrite32(0x00518DA0 + i*4, (DWORD)&MovieNames[i*65]);
	}
	dlogr(" Done");

	if(GetPrivateProfileIntA("Misc", "SharpshooterFix", 0, ini)) {
		dlog("Applying sharpshooter patch.");
		if(*((DWORD*)0x00424533) != 0xc003C003) {
			if( (*((DWORD*)0x00424533)!=0x0424548b) || (*((DWORD*)0x00424537)!=0xc229c001) || (*((DWORD*)0x0042453b)!=0x04245489) ) return false;
			SafeWrite32(0x00424533, 0xc003c003);
			SafeWrite32(0x00424537, 0x04244429);
			SafeWrite32(0x0042453b, 0x90909090);
		}
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "PathfinderFix", 0, ini)) {
		dlog("Applying pathfinder patch.");
		if( (*((DWORD*)0x004C1FF2)!=0xFFFD4B82) || (*((DWORD*)0x004C1C79)!=0xFFFE184F) ) return false;
		SafeWrite32(0x004C1FF2, ((DWORD)&PathfinderFix3) - 0x004c1ff6);
		SafeWrite32(0x004C1C79, ((DWORD)&PathfinderFix) - 0x004c1c7d);
		MapMulti=(double)GetPrivateProfileIntA("Misc", "WorldMapTimeMod", 100, ini)/100.0;
		dlogr(" Done");
	}

	DWORD delay=GetPrivateProfileIntA("Misc", "WorldMapFPS", 0, ini);
	if(delay) {
		dlog("Applying world map fps patch.");
		if(*((WORD*)0x004CAFB9)==0x3d40) 
			return false;
		else if(*((WORD*)0x004CAFB9)==0x0000) {
			AvailableGlobalScriptTypes|=2;
			SafeWrite32(0x004BFE5E, ((DWORD)&WorldMapSpeedPatch2) - 0x004BFE62);
			if(GetPrivateProfileIntA("Misc", "ForceLowResolutionTimer", 0, ini)||!QueryPerformanceFrequency((LARGE_INTEGER*)&wm_perfadd)||wm_perfadd<=1000) {
				wm_wait=1000.0/(double)delay;
				wm_nexttick=GetTickCount();
				wm_usingperf=false;
			} else {
				wm_usingperf=true;
				wm_perfadd/=delay;
				wm_perfnext=0;
			}
		}
		dlogr(" Done");
	} else {
		delay=GetPrivateProfileIntA("Misc", "WorldMapDelay", 0, ini);
		if(delay) {
			if(*((WORD*)0x004CAFB9)==0x3d40) 
				SafeWrite32(0x004CAFBB, delay);
			else if(*((WORD*)0x004CAFB9)==0x0000) {
				SafeWrite32(0x004BFE5E, ((DWORD)&WorldMapSpeedPatch) - 0x004BFE62);
				WorldMapLoopCount=delay;
			}
		} else {
			if(*(DWORD*)0x004BFE5E==0x0000d816) {
				SafeWrite32(0x004BFE5E, ((DWORD)&WorldMapHook) - 0x004BFE62);
			}
		}
	}

	delay=GetPrivateProfileIntA("Misc", "WorldMapEncounterFix", 0, ini);
	if(delay) {
		dlog("Applying world map encounter patch.");
		SafeWrite32(0x004bfee1, ((DWORD)&WorldMapEncPatch1) - 0x004bfee5);
		SafeWrite32(0x004c0663, ((DWORD)&WorldMapEncPatch3) - 0x004c0667);//replaces 'call Difference(GetTickCount(), TicksSinceLastEncounter)'
		SafeWrite16(0x004c0668, GetPrivateProfileIntA("Misc", "WorldMapEncounterRate", 5, ini)); //replaces cmp eax, 0x5dc with cmp eax, <rate>
		SafeWrite16(0x004c0677, 0xE890); //nop, call relative. Replaces 'mov TicksSinceLastEncounter, ecx'
		SafeWrite32(0x004c0679, ((DWORD)&WorldMapEncPatch2) - 0x004c067D);
		SafeWrite8(0x004c232d, 0xb8);	//'mov eax, 0', replaces 'mov eax, GetTickCount()'
		SafeWrite32(0x004c232e, 0);
		dlogr(" Done");
	}
	
	if(GetPrivateProfileIntA("Misc", "DialogueFix", 0, ini)) {
		dlog("Applying dialogue patch.");
		if(*((BYTE*)0x00446848)!=0x30) return false;
		SafeWrite8(0x00446848, 0x31);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "ExtraKillTypes", 0, ini)) {
		dlog("Applying extra kill types patch.");
		KillCounterInit(true);
		dlogr(" Done");
	} else KillCounterInit(false);

	if(GetPrivateProfileIntA("Misc", "ScriptExtender", 0, ini)) {
		dlog("Applying script extender patch.");
		ScriptExtenderSetup();
		dlog(".");
		LoadGameHookInit();
		dlog(".");
		PerksInit();
		dlog(".");
		KnockbackInit();
		dlog(".");

		//perk_owed hooks
		SafeWrite8(0x004AFB2F, 0xe8);								//call LevelUpHook
		SafeWrite32(0x004AFB30, (DWORD)&LevelUpHook - 0x004AFB34);	//replaces 'mov edx, ds:[PlayerLevel]
		SafeWrite8(0x004AFB34, 0x90);

		SafeWrite8(0x0043C2E9, 0xeb); //jmp 0x2e
		SafeWrite8(0x0043C2EA, 0x2e); //replaces the block of code which checks if the player has gained a perk (now handled in level up code)

		SafeWrite8(0x0043C362, 0xe8);						//call sub_43401C, dec byte ptr ds:[0x00570A29]
		SafeWrite32(0x0043C363, 0x0043410C - 0x0043C367);	//replaces call sub_43401C, mov byte ptr ds:[0x00570A29], 0
		SafeWrite8(0x0043C367, 0x3e);
		SafeWrite16(0x0043C368, 0x0dfe);
		SafeWrite32(0x0043C36a, 0x00570A29);
		SafeWrite8(0x0043C36e, 0x90);

		//Ray's combat_p_proc fix
		SafeWrite32(0x0425253, ((DWORD)&Combat_p_procFix) - 0x0425257);
		SafeWrite8(0x0424dbc, 0xE9);
		SafeWrite32(0x0424dbd, 0x00000034); 
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "WorldMapCitiesListFix", 0, ini)) {
		dlog("Applying world map cities list patch.");
		if(*((DWORD*)0x004C04BA)!=0x00001CDE) return false;

		SafeWrite32(0x004C04BA, ((DWORD)&ScrollCityListHook) - 0x004C04BE);
		SafeWrite32(0x004C04C9, ((DWORD)&ScrollCityListHook) - 0x004C04CD);
		SafeWrite32(0x004C4A35, ((DWORD)&ScrollCityListHook) - 0x004C4A39);
		SafeWrite32(0x004C4A3E, ((DWORD)&ScrollCityListHook) - 0x004C4A42);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "CitiesLimitFix", 0, ini)) {
		dlog("Applying cities limit patch.");
		if(*((BYTE*)0x004BF3BB)!=0xeb) {
			if(*((BYTE*)0x004BF3BB)!=0x74) return false;
			SafeWrite8(0x004BF3BB, 0xeb);
		}
		dlogr(" Done");
	}

	DWORD WorldMapSlots=GetPrivateProfileIntA("Misc", "WorldMapSlots", 0, ini);
	if(WorldMapSlots&&WorldMapSlots<128) {
		dlog("Applying world map slots patch.");
		if(*((DWORD*)0x004C21FB)!=0x00E6EA81) return false;
		if(WorldMapSlots<7) WorldMapSlots=7;
		mapSlotsScrollMax = (WorldMapSlots-7)*27;
		if(WorldMapSlots<25) SafeWrite32(0x004C21FD, 230 - (WorldMapSlots-17)*27);
		else {
			SafeWrite8(0x004C21FC, 0xC2);
			SafeWrite32(0x004C21FD, 2 + 27*(WorldMapSlots-26));
		}
		dlogr(" Done");
	}

	int limit=GetPrivateProfileIntA("Misc", "TimeLimit", 13, ini);
	if(limit==-2) limit=14;
	if(limit==-3) {
		dlog("Applying time limit patch (-3).");
		limit=-1;
		AddUnarmedStatToGetYear=1;

		SafeWrite32(0x004392F9, ((DWORD)&GetDateWrapper) - 0x004392Fd);
		SafeWrite32(0x00443809, ((DWORD)&GetDateWrapper) - 0x0044380d);
		SafeWrite32(0x0047E128, ((DWORD)&GetDateWrapper) - 0x0047E12c);
		SafeWrite32(0x004975A3, ((DWORD)&GetDateWrapper) - 0x004975A7);
		SafeWrite32(0x00497713, ((DWORD)&GetDateWrapper) - 0x00497717);
		SafeWrite32(0x004979Ca, ((DWORD)&GetDateWrapper) - 0x004979Ce);
		SafeWrite32(0x004C3CB6, ((DWORD)&GetDateWrapper) - 0x004C3CBa);
		dlogr(" Done");
	}
	if(limit<=14&&limit>=-1&&limit!=13) {
		dlog("Applying time limit patch.");
		if(*((BYTE*)0x004A34EC)!=13) return false;
		if(*((BYTE*)0x004A3544)!=13) return false;
		if(limit==-1) {
			SafeWrite32(0x004A34Fa, ((DWORD)&TimerReset) - 0x004A34Fe);
			SafeWrite32(0x004A3552, ((DWORD)&TimerReset) - 0x004A3556);

			SafeWrite32(0x004A34EF, 0x90909090);
			SafeWrite32(0x004A34f3, 0x90909090);
			SafeWrite16(0x004A34f7, 0x9090);
			SafeWrite32(0x004A34FE, 0x90909090);
			SafeWrite16(0x004A3502, 0x9090);

			SafeWrite32(0x004A3547, 0x90909090);
			SafeWrite32(0x004A354b, 0x90909090);
			SafeWrite16(0x004A354f, 0x9090);
			SafeWrite32(0x004A3556, 0x90909090);
			SafeWrite16(0x004A355a, 0x9090);
		} else {
			SafeWrite8(0x004A34EC, limit);
			SafeWrite8(0x004A3544, limit);
		}
		dlogr(" Done");
	}

	DWORD debugmode=GetPrivateProfileIntA("Misc", "DebugMode", 0, ini);
	if(debugmode) {
		dlog("Applying debugmode patch.");
		//If the player is using an exe with the debug patch already applied, just skip this block without erroring
		if(*((DWORD*)0x00444A64)!=0x082327e8) {
			if(*((DWORD*)0x00444A64)!=0x0f01fe83) return false;
			SafeWrite32(0x00444A64, 0x082327e8);
			SafeWrite32(0x00444A68, 0x0120e900);
			SafeWrite8(0x00444A6D, 0);
			SafeWrite32(0x00444A6E, 0x90909090);
		}
		//watcom library seems to cache environment variables at program startup, so can't just call SetEnvironmentVariable here
		if(*((DWORD*)0x004C6D9B)!=0x0195e5e8) return false;
		SafeWrite8(0x004C6D9B, 0xb8);
		if(debugmode==1) SafeWrite32(0x004C6D9C, (DWORD)debugGnw);
		else SafeWrite32(0x004C6D9C, (DWORD)debugLog);
		dlogr(" Done");
	}

	npcautolevel=GetPrivateProfileIntA("Misc", "NPCAutoLevel", 0, ini)!=0;
	if(npcautolevel) {
		dlog("Applying npc autolevel patch.");
		if(*((DWORD*)0x00495D24)!=0x00000129) return false;
		SafeWrite16(0x00495D22, 0x9090);
		SafeWrite32(0x00495D24, 0x90909090);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "SingleCore", 0, ini)) {
		dlog("Applying single core patch.");
		HANDLE process=GetCurrentProcess();
		SetProcessAffinityMask(process, 1);
		CloseHandle(process);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "OverrideArtCacheSize", 0, ini)) {
		dlog("Applying override art cache size patch.");
		SafeWrite32(0x00418867, 0x90909090);
		SafeWrite32(0x00418872, 256);
		dlogr(" Done");
	}

	char elevPath[MAX_PATH];
	GetPrivateProfileString("Misc", "ElevatorsFile", "", elevPath, MAX_PATH, ini);
	if(strlen(elevPath)>0) {
		dlog("Applying elevator patch.");
		ElevatorsInit(elevPath);
		dlog(" Done");
	}

	/*DWORD horrigan=GetPrivateProfileIntA("Misc", "DisableHorrigan", 0, ini);
	if(horrigan) {
		if(*((BYTE*)0x004C06D8)!=0x75) return false;
		SafeWrite8(0x004C06D8, 0xeb);
	}*/

#ifndef WIN9X
	DWORD eax=GetPrivateProfileIntA("Sound", "EAX", 0, ini);
	if(eax) {
		dlog("Applying eax patch.");
		if(strcmp((char*)0x0050FB90, "DSOUND.DLL")) return false;
		SafeWriteStr(0x0050FB90, "ddraw.dll");
		dlogr(" Done");
	}
#endif

	if(GetPrivateProfileIntA("Misc", "BlackSkilldexFix", 0, ini)) {
		dlog("Applying black skilldex patch.");
		HookCall(0x00497D0F, BlackSkilldexFix);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "PrintToFileFix", 0, ini)) {
		dlog("Applying print to file patch.");
		SafeWrite32(0x006C0364, (DWORD)&FakeFindFirstFile);
		SafeWrite32(0x006C0368, (DWORD)&FakeFindNextFile);
		dlogr(" Done");
	}

	if(GetPrivateProfileIntA("Misc", "AdditionalWeaponAnims", 0, ini)) {
		dlog("Applying additional weapon animations patch.");
		if(*(BYTE*)(0x419320)!=0xb) return false;
		SafeWrite8(0x419320, 0xf);
		dlogr(" Done");
	}

	dlogr("Leave DllMain2");
	return true;
}

#if 0
static void _stdcall OpenFileHook2(const char* _str) {
	char str[260];
	strcpy_s(str, _str);
	_strlwr_s(str);
	if(!strcmp(str, "c:\\games\\fallout2\\data\\art\\critters\\hfjmpsga.frm")) {
	//if(!strcmp(str, "c:\\games\\fallout2\\data\\proto\\items\\00000013.pro")) {
		//DebugBreak();
	}
}
static void _declspec(naked) OpenFileHook() {
	_asm {
		mov eax, [esp+4];
		pushad;
		push eax;
		call OpenFileHook2;
		popad;
		mov eax, [CreateFileA];
		jmp eax;
	}
}
static void __cdecl BltHook(BYTE *dest,int dPitch,BYTE *source,int sPitch,int width,int height) {
	//DWORD stack;
	//_asm mov stack, esp;
	//if((DWORD)dest>stack && (DWORD)dest>stack
	if((DWORD)dest > 0x00100000 && (DWORD)source > 0x00100000) {
		dPitch*=4;
		sPitch*=4;
		width*=4;
	}
	for(int y=0;y<height;y++) {
		for(int x=0;x<width;x++) dest[y*dPitch + x]=source[y*sPitch + x];
	}
}
/*static void _declspec(naked) BltHook() {
	_asm {
		mov eax, [esp+8];
		sal eax, 2;
		mov [esp+8], eax;
		mov eax, [esp+0x10];
		sal eax, 2;
		mov [esp+0x10], eax;
		mov eax, [esp+0x14];
		sal eax, 2;
		mov [esp+0x14], eax;
		mov eax, 0x004E0DB0;
		jmp eax;
	}
}*/
static void _declspec(naked) MemAllocHook() {
	_asm {
		cmp eax, 0x40000000;
		jge end;
		sal eax, 2;
end:
		push ebx;
		push ecx;
		push edx;
		push esi;
		push edi;
		mov ebx, 0x004EF1CA;
		jmp ebx;
	}
}
#endif
bool _stdcall DllMain(HANDLE hDllHandle, DWORD dwReason, LPVOID  lpreserved) {
	if(dwReason==DLL_PROCESS_ATTACH) {
		//BlockCall(0x00497D0F);

		//SafeMemSet(0x004998EB, 0x90, 6);

		/*BlockCall(0x004998D1);
		SafeMemSet(0x004998D8, 0x90, 6);
		
		//Block add button calls
		SafeWrite32(0x004999AC, 0x9024c483);
		SafeWrite8(0x004999AB, 0x90);
		SafeWrite8(0x0049993E, 0x90);
		SafeWrite32(0x0049993F, 0x9024c483);*/

#ifdef WIN9X
		memInit();
		DisableThreadLibraryCalls(GetModuleHandle("sfall.dll"));
#else
		HKEY key;
		if(!RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows NT\\CurrentVersion\\AppCompatFlags\\Layers", 0, STANDARD_RIGHTS_READ|KEY_QUERY_VALUE, &key)) {
			char filepath[MAX_PATH];
			DWORD size=MAX_PATH;
			if(GetModuleFileNameA(GetModuleHandleA(0), filepath, MAX_PATH)) {
				DWORD type;
				if(!RegQueryValueEx(key, filepath, 0, &type, (BYTE*)filepath, &size)) {
					if(type&(REG_EXPAND_SZ|REG_MULTI_SZ|REG_SZ)&&size) {
						if(strstr(filepath, "256COLOR")||strstr(filepath, "640X480")||strstr(filepath, "WIN")) {
							MessageBoxA(0, "Fallout appears to be running in compatibility mode", "Error", 0);
							ExitProcess(-1);
						}
					}
				}
			}
			RegCloseKey(key);
		}
#endif
		//SafeWrite32(0x004EE1E1, (DWORD)&OpenFileHook - 0x004EE1E5);
		//SafeWrite32(0x004D36F7, (DWORD)&BltHook - 0x004D36Fb);
		//SafeWrite8(0x004EF1C5, 0xe9);
		//SafeWrite32(0x004EF1C6, (DWORD)&MemAllocHook - 0x004EF1Ca);
		//SafeWrite8(0x004CB850, 0xe9);
		//SafeWrite32(0x004CB851, (DWORD)&LockPrimarySurf8 - 0x004CB855);

		//SafeWrite32(0x0051DED0, (DWORD)&MemAllocHook);
		//SafeWrite8(0x00419C56, 0x3e);
		//SafeWrite8(0x004D6FD8, 0xc3);
		//SafeWrite32(0x004CB8DB, 0x90909090);
		//SafeWrite8(0x004CB8DF, 0x90);
		//SafeWrite32(0x0044451E, 0x90909090);
		//SafeWrite16(0x00444522, 0x9090);
		//SafeWrite32(0x004CA506, 0x90909090);
		//SafeWrite16(0x004CA50a, 0x9090);

		//SafeWrite16(0x004EDFC3, 0x9090);
	//SafeWrite16(0x0048BF67, 0x9090); //Draws out the local map
		//SafeWrite16(0x0048BF7B, 0x9090);

		//First DrawScreen8 call
		//SafeWrite32(0x0044451E, 0x90909090);
		//SafeWrite16(0x00444522, 0x9090);

		//MainMenu DrawScreen8 call (Handles everything except mouse pointer)
		//SafeWrite32(0x004D7414, 0x90909090);
		//SafeWrite16(0x004D7418, 0x9090);

	//Prevents drawing to the screen
	//SafeWrite32(0x004E0E5C, 0x90909090);
		bool cmdlineexists=false;
		char* cmdline=GetCommandLineA();
		if(GetPrivateProfileIntA("Main", "UseCommandLine", 0, ".\\ddraw.ini")) {
			while(cmdline[0]==' ') cmdline++;
			bool InQuote=false;
			int count=-1;

			while(true) {
				count++;
				if(cmdline[count]==0) break;;
				if(cmdline[count]==' '&&!InQuote) break;
				if(cmdline[count]=='"') {
					InQuote=!InQuote;
					if(!InQuote) break;
				}
			}
			if(cmdline[count]!=0) {
				count++;
				while(cmdline[count]==' ') count++;
				cmdline=&cmdline[count];
				cmdlineexists=true;
			}
		}

		if(cmdlineexists&&strlen(cmdline)) {
			strcpy_s(ini, ".\\");
			strcat_s(ini, cmdline);
			HANDLE h = CreateFileA(cmdline, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
			if(h!=INVALID_HANDLE_VALUE) CloseHandle(h);
			else {
				MessageBox(0, "You gave a command line argument to fallout, but it couldn't be matched to a file\n" \
					"Using default ddraw.ini instead", "Warning", MB_TASKMODAL);
				strcpy_s(ini, ".\\ddraw.ini");
			}
		} else strcpy_s(ini, ".\\ddraw.ini");

		if(!DllMain2()) {
			MessageBox(0, "You're trying to use sfall with an incompatible version of fallout\n" \
				"Was expecting '" TARGETVERSION "'", "Error", MB_TASKMODAL);
			ExitProcess(1);
		}
	}
	return true;
}

#ifdef WIN9X

#endif