#define _WIN32_WINDOWS 0x0400
#define WINVER 0x0400

#define _HAS_ITERATOR_DEBUGGING 0
#define __STDC_WANT_SECURE_LIB__ 0
#define _SECURE_SCL 0
#define _HAS_EXCEPTIONS 0

void memInit();

void strcat_s(char* a, const char* b);
void strcat_s(char* a, int i, const char* b);
void strcpy_s(char* a, const char* b);
void strcpy_s(char* a, int i, const char* b);
void _cdecl _itoa_s(int val, char* buf, int redix);
void _cdecl _itoa_s(int val, char* buf, int i, int redix);
const char* strstr2(const char* a,const char* b);

void *operator new (size_t);
void operator delete (void *);
void *operator new[] (size_t);      // for arays
void operator delete[] (void *);

double _cdecl modf(double a, double* b);

//memset and memcpy are protected compiler intrinsics, so can't overload them
void memcpy2(void* to, const void* from, int size);
void memset2(void* to, char val, int size);

//This file is force included, so include this now or the memset defines end up being used in there
#include <string.h>

#define memset(a,b,c) memset2(a,b,c)
#define memcpy(a,b,c) memcpy2(a,b,c)
#define strstr(a,b) strstr2(a,b)

double _cdecl floor(double a);
